// SusiePlugIn export library for Delphi
// Copyright(C)'2000 buin2gou
// 
// ̃R|[lg͎RɎgpĂč\܂
// ]ځEςRłBs̃\tgɎgpĂCeB
// ̐͐΂ɂ肦܂BKv܂B

unit SPILib;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  // TPictureInfo
  PPictureInfo = ^TPictureInfo;
  TPictureInfo = packed record
    Left:       Longint;
    Top:        Longint;
    Width:      Longint;
    Height:     Longint;
    x_Density:  Word;
    y_Density:  Word;
    colorDepth: Smallint;
    hInfo:      HLOCAL;
  end;

  // TFileInfo
  PFileInfo = ^TFileInfo;
  TFileInfo = record
    Method:    array[0..7] of Char;
    Position:  Longint;
    CompSize:  Longint;
    FileSize:  Longint;
    TimeStamp: Longint;
    Path:      array[0..199] of Char;
    FileName:  array[0..199] of Char;
    CRC:       Longint;
  end;

  PFIleInfoArray=^TFIleInfoArray;
  TFIleInfoArray=array[0..512] of TFileInfo;

  // TProgressCallback(Callback function)
  TProgressCallback = function(nNum, nDenom: Integer; lData: Longint): Integer;stdcall;

    // Plug-inɊւ𓾂
  FGetPluginInfo =function(InfoNo: Integer; Buf: PChar; BufLen: Integer): Integer; stdcall;
    // WJ\(ΉĂ)t@C`ׂ
  FIsSupported   =function(FileName: PChar; DW: DWORD): Integer; stdcall;
    // 摜t@CɊւ𓾂
  FGetPictureInfo=function(Buf: PChar; Len: Longint; Flag: Integer;var PictureInfo: TPictureInfo): Integer; stdcall;
    // 摜WJ
  FGetPicture    =function(Buf: PChar; Len: Longint; Flag: Integer;var HBInfo: HLOCAL; var HBm: HLOCAL;ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall;
    // vr[EJ^O\p摜kWJ[eB
  FGetPreview    =function(Buf: PChar; Len: Longint; Flag: Integer;var HBInfo: HLOCAL; var HBm: HLOCAL;ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall;

  //A[JCu֌W

    // A[JCûׂẴt@C̏擾
  FGetArchiveInfo=function(Buf: PChar; Len: Longint; Flag: Integer;var PictureInfoHandle: HLocal): Integer; stdcall;
    // A[JCu̎w肵t@C̏擾
  FGetFileInfo   =function(Buf: PChar; Len: Longint; FileName: PChar; Flag: Integer;var FileInfo: TFileInfo): Integer; stdcall;
    // A[JCũt@C擾
  FGetFile       =function(Src: PChar; Len: Longint; Dest: PChar; Flag: Integer;ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall;
    // Plug-inݒ_CAO\
  FConfigurationDlg=function (Parent: HWND; fnc: Integer): Integer; stdcall;


  //摜vOC
  PPicPlug=^TPicPlug;
  TPicPlug=record
      //ckk̃nh
      DllHandle :THandle;

      //vOCf[^
      sPath     :AnsiString;
      sVersion  :AnsiString;
      sFinleInfo:AnsiString;
      sFileExt  :AnsiString;
      sFileType :AnsiString;

      //֐
      GetPluginInfo   :FGetPluginInfo;
      IsSupported     :FIsSupported;
      GetPictureInfo  :FGetPictureInfo;
      GetPicture      :FGetPicture;
      GetPreview      :FGetPreview;
      ConfigurationDlg:FConfigurationDlg;
  end;

  //A[JCuvOC
  PArcPlug=^TArcPlug;
  TArcPlug=record
      //ckk̃nh
      DllHandle :THandle;

      //vOCf[^
      sPath     :AnsiString;
      sVersion  :AnsiString;
      sFinleInfo:AnsiString;
      sFileExt  :AnsiString;
      sFileType :AnsiString;

      //֐
      GetPluginInfo :FGetPluginInfo;
      IsSupported   :FIsSupported;
      GetArchiveInfo:FGetArchiveInfo;
      GetFileInfo   :FGetFileInfo;
      GetFile       :FGetFile;
      ConfigurationDlg:FConfigurationDlg;
  end;



type
  TSpiLib32 = class(TComponent)
  private
    { Private 錾 }

    //vOCXg
    PicList:TList;
    ArcList:TList;
    //ϐ
    ARCfilters:AnsiString;
    PICfilters:AnsiString;

    APIL      :TStrings;
    SPIL      :TStrings;


  protected
    { Protected 錾 }
  public
    { Public 錾 }


    //EJ
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    //vOCǂݍ݁EJ
    procedure LoadPlugIn(Dir:String);
    procedure LoadPlugInFromList(List:TStringList);
    procedure LoadPlugInArc(Dir:String);
    procedure FreePlugIn;

    //摜ǂݍ݊֐
    procedure LoadFromStream(Stream:TStream;BMP:TBitmap);
    procedure LoadFromFile(FileName:String;BMP:TBitmap);
    procedure LoadFromMemory(Buf: PChar; Len: Longint;BMP:TBitmap);

    {
    //A[JCu摜ǂݏo
    procedure LoadFromStreamArcPic(Stream,Stream2:TStream;BMP:TBitmap);
    procedure LoadFromFileArcPic(ARCName,PicName:String;BMP:TBitmap);
    }
    //A[JCut@Ĉ܂܃Z[u
    procedure SaveToFile(ArcFIleName,FileName:String);
    procedure SaveToStream(FileName,ArcFileName:String;Stream:TStream);
    procedure SaveToMemory(Buf: PChar;FIleName,ArcFileName:String);

    //vOC̃Xg
    procedure ListArc(List:TStrings;bClear:Boolean);
    procedure ListPic(List:TStrings;bClear:Boolean);

    //A[JCut@C̃Xg
    procedure ArcFileList(ArcFileName:String;List:TStrings);

    //T|[gĂ邩
    function SupportArcFile(FIleName:String):Boolean;

  published
    { Published 錾 }
    //vpeB
    property  AFilter: String read ARCFilters;
    property  PFilter: String read PICFilters;
    property  ArcPlugInList:TStrings read APIL;
    property  PicPlugInList:TStrings read SPIL;

  end;

procedure Register;

implementation

const
	SearchAttr = faReadOnly + faSysFile + faArchive;


procedure Register;
begin
  RegisterComponents('buin2gou', [TSpiLib32]);
end;

constructor TSpiLib32.Create(AOwner: TComponent);
begin
  Inherited Create(AOwner);

  //Xg̃NGCg
  ArcList:=TList.Create;
  PicList:=TList.Create;

  //vOC
  APIL:=TStringList.Create;
  SPIL:=TStringList.Create;

  APIL.Clear;
  SPIL.Clear;

end;

destructor TSpiLib32.Destroy;
begin

  FreePlugIn;

  //Xg̊J
  ArcList.Free;
  PicList.Free;

  //vOC
  APIL.Free;
  SPIL.Free;

  Inherited;
end;

procedure TSpiLib32.LoadPlugIn(Dir:String);
var SR  :TSearchRec;
    Re  :Integer;
    s   :String;
    pPo :Pointer;
    pPic:PPicPlug;
    buf :PChar;
    List:TStringList;
    i   :Integer;
    bOk :Boolean;
begin

 //wfBNgɃZbg
 List:=TStringList.Create;
 List.Clear;


 Re:=FindFirst(Dir+'*.SPI', SearchAttr, SR);
 try
   while Re=0 do begin
         //ckk̃tpX𓾂
         s:=Dir + StrPas(SR.FindData.cFileName);

         List.Add(s);
         //
         Re:=FindNext(SR);
   end;
 finally
   FindClose(SR);
 end;
 LoadPlugInFromList(List);

  List.Free;


end;

procedure TSpiLib32.LoadPlugInFromList(List:TStringList);
var SR  :TSearchRec;
    Re  :Integer;
    s   :String;
    pPo :Pointer;
    pPic:PPicPlug;
    buf :PChar;
    i   :Integer;
    bOk :Boolean;
begin
 //
 PICfilters:='';
 GetMem(buf,256);



 for i:=0 to List.COunt-1 do begin
   s:=List[i];

   bOK:=True;
   //ckk̓ǂݍ݁E擾
   New(pPic);

   pPic.DllHandle:=LoadLibrary(PChar(s));
   If pPic.DllHandle<>0 then begin
     //֐̃AhX擾
     pPo:=GetProcAddress(pPic.DllHandle,'GetPluginInfo');
     If pPo<>nil then begin
        //A[JCuvOC摜vOC
        @pPic.GetPluginInfo:=pPo;
        pPic.GetPluginInfo(0,buf,255);
        s:=AnsiString(buf);


        If s='00IN' then begin
           //摜vOC擾


           //vOC̎擾
           @pPic.GetPluginInfo:=pPo;

           pPic.GetPluginInfo(0,buf,255);
           pPic.sFinleInfo:=AnsiString(buf);

           pPic.GetPluginInfo(1,buf,255);
           pPic.sVersion:=AnsiString(buf);

           pPic.GetPluginInfo(2,buf,255);
           pPic.sFileExt:=AnsiString(buf);

           pPic.GetPluginInfo(3,buf,255);
           pPic.sFileType:=AnsiString(buf);

           pPic.sPath:=ExtractFilepath(s);

           //֐̎擾
           @pPic.GetPicture      :=GetProcAddress(pPic.DllHandle,'GetPicture');
           @pPic.GetPictureInfo  :=GetProcAddress(pPic.DllHandle,'GetPictureInfo');
           @pPic.GetPreview      :=GetProcAddress(pPic.DllHandle,'GetPreview');
           @pPic.IsSupported     :=GetProcAddress(pPic.DllHandle,'IsSupported');
           @pPic.ConfigurationDlg:=GetProcAddress(pPic.DllHandle,'ConfigurationDlg');

           PicList.Add(pPic);
           PicFIlters:=PicFilters+pPic.sFileExt+';';

         end else begin
           bOK:=False;
         end;
      end else begin
         bOK:=False;
      end;
   end else begin
      bOK:=False;
   end;

   If not bOK then begin
      //ckkJ
      FreeLibrary(pPic.DllHandle);
      DisPose(pPic);
   end;
  end;
  FreeMEM(buf);

  ListPic(SPIL,False);


end;

procedure TSpiLib32.LoadPlugInArc(Dir:String);
var SR  :TSearchRec;
    Re  :Integer;
    s   :String;
    pPo :Pointer;
    pArc:PArcPlug;
    buf :PChar;
    List:TStringList;
    i   :Integer;
    bOk :Boolean;
begin
 //
 ARCfilters:='';

 GetMem(buf,256);

 //wfBNgɃZbg
 List:=TStringList.Create;
 Re:=FindFirst(Dir+'*.SPI', SearchAttr, SR);
 try
   while Re=0 do begin
         //ckk̃tpX𓾂
         s:=Dir + StrPas(SR.FindData.cFileName);

         List.Add(s);
         //
         Re:=FindNext(SR);
   end;
 finally
   FindClose(SR);
 end;

 for i:=0 to List.COunt-1 do begin
   s:=List[i];


   bOK:=True;
   //ckk̓ǂݍ݁E擾
   New(pArc);
   pArc.DllHandle:=LoadLibrary(PChar(s));
   If pArc.DllHandle<>0 then begin
     //֐̃AhX擾
     pPo:=GetProcAddress(pArc.DllHandle,'GetPluginInfo');
     If pPo<>nil then begin
        //A[JCuvOC摜vOC
        @pArc.GetPluginInfo:=pPo;
        pArc.GetPluginInfo(0,buf,255);
        s:=AnsiString(buf);

        If s='00AM' then begin
           //A[JCuvOC擾

           //vOC̎擾
           @pArc.GetPluginInfo:=pPo;

           pArc.GetPluginInfo(0,buf,255);
           pArc.sFinleInfo:=AnsiString(buf);

           pArc.GetPluginInfo(1,buf,255);
           pArc.sVersion:=AnsiString(buf);

           pArc.GetPluginInfo(2,buf,255);
           pArc.sFileExt:=AnsiString(buf);

           pArc.GetPluginInfo(3,buf,255);
           pArc.sFileType:=AnsiString(buf);

           //֐̎擾
           @pARC.GetArchiveInfo  :=GetProcAddress(pArc.DllHandle,'GetArchiveInfo');
           @pARC.GetFile         :=GetProcAddress(pArc.DllHandle,'GetFile');
           @pARC.GetFileInfo     :=GetProcAddress(pArc.DllHandle,'GetFileInfo');
           @pARC.IsSupported     :=GetProcAddress(pArc.DllHandle,'IsSupported');
           @pARC.ConfigurationDlg:=GetProcAddress(pArc.DllHandle,'ConfigurationDlg');

           ArcList.Add(pArc);
           ArcFIlters:=ArcFilters+pArc.sFileExt+';';
         end else begin
           bOK:=False;
         end;
      end else begin
         bOK:=False;
      end;
   end else begin
      bOK:=False;
   end;

   If not bOK then begin
      //ckkJ
      FreeLibrary(pArc.DllHandle);
      DisPose(pArc);
   end;
  end;
  List.Free;
  FreeMEM(buf);

  //Xg
  ListArc(APIL,False);

end;


procedure TSpiLib32.FreePlugIn;
var i,imax:Integer;
    pPic  :PPicPlug;
    pArc  :PArcPlug;
begin

  //摜vOCJ
  imax:=PicList.Count;
  If imax>0 then begin
     for i:=0 to imax-1 do begin
         pPic:=PicList.Items[i];
         FreeLibrary(pPic.DLLHandle);
         DisPose(pPic);
     end;
  end;

  //A[JCuvOCJ
  imax:=ArcList.Count;
  If imax>0 then begin
     for i:=0 to imax-1 do begin
         pArc:=ArcList.Items[i];
         FreeLibrary(pArc.DLLHandle);
         DisPose(pARC);
     end;
  end;
end;

procedure TSpiLib32.LoadFromStream(Stream:TStream;BMP:TBitmap);
var ms:TMemoryStream;
begin

 //XXg[𐶐
 ms:=TMemoryStream.Create;
 try
  //烍[hB
  ms.LoadFromStream(Stream);
  LoadFromMemory(ms.Memory,Stream.Size,BMP);
 finally
  ms.Free;
 end;


end;

procedure TSpiLib32.LoadFromMemory(Buf: PChar; Len: Longint;BMP:TBitmap);
var
    pHBm    :HGLOBAL;
    pHBInfo :HGLOBAL;
    pHBmP   :Pointer;
    pHBInfoP:Pointer;
    pbmi    :^TBitmapInfo;
    pPic    :PPicPlug;
    i       :Integer;
begin



    for i:=0 to PicList.Count-1 do begin
        pPic:=PicList.Items[i];

        //Ή摜`FbN
        If pPic.IsSupported(nil,DWORD(buf))<>0 then begin

           pPic.GetPicture(buf,len, $001, pHBInfo, pHBm,nil,0);

           try
              try
               //rbg}bv̓ǂݍ
               pHBmP   :=GlobalLock(pHBm);
               pHBInfoP:=GlobalLock(pHBInfo);
               pbmi    :=pHBInfoP;

               //TCY̐ݒ
               Bmp.Width :=pbmi^.bmiHeader.biWidth;
               Bmp.Height:=pbmi^.bmiHeader.biHeight;

               //]
               SetDiBits(Bmp.Canvas.Handle,Bmp.Handle,0,pbmi^.bmiHeader.biHeight,pHBmP, pbmi^,DIB_RGB_COLORS);
              except
               abort;
              end;
           finally
             GlobalUnlock(pHBm);
             GlobalUnlock(pHBInfo);
             GlobalFree(pHBm);
             GlobalFree(pHBInfo);
           end;
           break;
        end;
    end;
end;


procedure TSpiLib32.LoadFromFile(FileName:String;BMP:TBitmap);
var Stream:TMemoryStream;
begin

    Stream:=TMemorySTream.Create;
    try
      Stream.LoadFromFile(FileName);
      LoadFromStream(Stream,BMP);
    finally
      Stream.Free;
    end;
end;

procedure TSpiLib32.SaveToFile(ArcFIleName,FileName:String);
var ms:TMemoryStream;
begin

   ms :=TMemoryStream.Create;
   try
     SaveToStream(FileName,ArcFileName,ms);
     ms.SaveToFile(FileName);
   finally
     ms.Free;
   end;
end;

procedure TSpiLib32.SaveToStream(FileName,ArcFileName:String;Stream:TStream);
var ms:TMemoryStream;
begin

  ms:=TMemoryStream.Create;
  try
    ms.LoadFromStream(Stream);
    SaveToMemory(ms.Memory,FileName,ArcFileName);
  finally
    ms.Free;
  end;
end;

procedure TSpiLib32.SaveToMemory(Buf: PChar;FIleName,ArcFileName:String);
var i   :Integer;
    pArc:pArcPlug;
    finf:TFileInfo;
begin

    for i:=0 to ARCList.Count-1 do begin
        pArc:=ArcList.Items[i];

        //Ή摜`FbN
        If pArc.IsSupported(nil,DWORD(buf))<>0 then begin

           pArc.GetFileInfo(PChar(FileName),SizeOf(FileName),PChar(ArcFileName),0,finf);

           pArc.GetFile(PChar(FileName),finf.Position,buf,$001,nil,0);

           break;
        end;
    end;
end;

function TSpiLib32.SupportArcFile(FIleName:String):Boolean;
var i,j :Integer;
    pArc:pArcPlug;
    ms  :TMemoryStream;
begin

  Result:=False;

  ms:=TMemoryStream.Create;
  try
    ms.LoadFromFile(FileName);

    for i:=0 to ARCList.Count-1 do begin
        pArc:=ArcList.Items[i];

        //Ή摜`FbN
        j:=pArc.IsSupported(nil,DWORD(MS.Memory));

        If j<>0 then begin
           Result:=True;
           break;
        end;
    end;
  finally
    ms.Free;
  end;
end;

procedure TSpiLib32.ArcFileList(ArcFileName:String;List:TStrings);
var i,j :Integer;
    pArc:pArcPlug;
    LMem:HLOCAL;
    ms  :TMemoryStream;
    PInf:PFileInfoArray;
    AllCount:Integer;
    TInf:TFileInfo;
begin

  ms:=TMemoryStream.Create;
  try
    ms.LoadFromFile(ArcFileName);

    for i:=0 to ARCList.Count-1 do begin
        pArc:=ArcList.Items[i];
        //Ή摜`FbN
        If pArc.IsSupported(nil,DWORD(ms.Memory))<>0 then begin

           pArc.GetArchiveInfo(MS.Memory,MS.Size,0,LMEM);

           //LMEMbN擾
           PInf:=LocalLock(LMEM);
           try
            ALLCount:=LocalSize(LMEM) div SizeOf(TFileInfo);

            for j:=0 to ALLCount do begin
                If PInf^[j].Method[0]=#0 then break;

                TInf:=PInf[j];

                List.Add(TInf.FileName);

            end;
           finally
             LocalUnLock(LMEM);
           end;
           break;
        end;
    end;
  finally
    ms.Free;
  end;
end;



procedure TSpiLib32.ListArc(List:TStrings;bClear:Boolean);
var i   :Integer;
    pArc:PArcPlug;
    buf :PChar;
begin

   //obt@擾
   GetMem(buf,256);

   //Xg̃NA
   If bClear then List.Clear;

   for i:=0 to ARCList.Count-1 do begin
       //A[JCuvOC擾
       pArc:=ArcList.Items[i];

       //vOCf[^ǂݏo
       pArc.GetPluginInfo(1,buf,255);
       List.Add(buf);
   end;

   //obt@J
   FreeMem(buf);

end;

procedure TSpiLib32.ListPic(List:TStrings;bClear:Boolean);
var i   :Integer;
    pPic:PPicPlug;
    buf :PChar;
begin

   //obt@擾
   GetMem(buf,256);

   //Xg̃NA
   If bClear then List.Clear;

   for i:=0 to PicList.Count-1 do begin
       //A[JCuvOC擾
       pPic:=PicList.Items[i];

       //vOCf[^ǂݏo
       pPic.GetPluginInfo(1,buf,255);
       List.Add(buf);
   end;

   //obt@J
   FreeMem(buf);

end;


end.
